public:
	// Patches!
	void	MOD_Destruct_Post();
	void	MOD_Init_Post();
	void	MOD_CreatePartFile_Post();
	void	MOD_LoadPartFile_Post();
	void	MOD_AddGap_Post(uint32 start, uint32 end);
	void	MOD_FillGap_Post(uint32 start, uint32 end);

	CBytesPerSecond		Process(uint32 reducedownload, uint8 m_icounter, CBytesPerSecond allowed);
	Gap_Struct* 		MOD_FindGap(uint32 start, uint32 end) const; // netfinity
	// enkeyDev: ICS
	void				MOD_WriteIncPartStatus(CSafeMemFile* file);
	void    			MOD_NewSrcIncPartsInfo();
	// <--- enkeyDev: ICS
	uint16				MOD_FindNextPart(CUpDownClient* sender);
	// netfinity: Support for uploading/downloading from incomplete chunks
	//uint32			m_nPartDlPoint;			// Offset within a chunk to start downloading from
	// enkeyDev: ICS
	CArray<uint16,uint16>	m_SrcIncPartFrequency;
	int     m_ics_filemode;
	// <--- enkeyDev: ICS
	// MOD BEGIN netfinity:
public:
	virtual uint16 		MOD_GetPartSourceCount(uint16 part);
	uint32				MOD_GetRequestedSizeInPart(uint16 part) const;
	uint32				MOD_GetRequestedSizeInFile(void) const;
	uint16				MOD_GetDownloadingSourcesInPart(uint16 part, CUpDownClient* exclude_src = NULL) const;
	uint16				MOD_GetDownloadingSourcesInFile(CUpDownClient* exclude_src = NULL) const;
	uint32				MOD_GetDownloadingDatarateInPart(uint16 part, CUpDownClient* exclude_src = NULL) const;
	bool				MOD_DropStalledDownloads(CUpDownClient* pClient) const;
	void 				MOD_ProcessDL(CUpDownClient *cur_src, uint32 reducedownload, CBytesPerSecond allowed);
	void				MOD_CheckGapCache(uint16 part);
	void				MOD_InvalidateGapCache(uint16 part);
	void				MOD_SetGapCache(uint16 part, uint32 size);
	struct dataBlock
	{
		uint32	start;
		uint32	end;
	};
	class CPartStat
	{
	public:
		CPartStat() {gapCacheValid = false; isHashing = false; hashedBlocks = 0;}
		bool	gapCacheValid;
		uint32	gapSize;
		int		isHashing:1;
		uint64	hashedBlocks;
	};
	CArray<CPartStat> m_partStat;
private:
	void				MOD_OnPartHashValid(uint16 partNumber, bool bForceICH = false, bool bNoAICH = false);
	void				MOD_OnPartHashInvalid(uint16 partNumber, bool bForceICH = false, bool bNoAICH = false);
	// MOD END netfinity
